/*******************************************************************************
*                                                                              *
*	Setup Sample                                                               *
*                                                                              *
*   silex technology, Inc. CONFIDENTIAL                                        *
*                                                                              *
*----------+---------+---------------------------------------------------------*
*   t   | Version |                          e                           *
*----------+---------+---------------------------------------------------------*
* 10-02-20 |  1.0.0  |                                                         *
*----------+---------+---------------------------------------------------------*
* 10-02-20 |  1.1.0  | Windows 8 Ή                                          *
*----------+---------+---------------------------------------------------------*
*******************************************************************************/
#include <windows.h>
#include <commctrl.h>

#include "setup.h"


/*----------------------------------------------------------------------------*/
/*		萔`                                                              */
/*----------------------------------------------------------------------------*/
#ifndef PROCESSOR_ARCHITECTURE_IA32_ON_WIN64
#define PROCESSOR_ARCHITECTURE_IA32_ON_WIN64	9
#endif
#ifndef PROCESSOR_ARCHITECTURE_AMD64
#define PROCESSOR_ARCHITECTURE_AMD64			10
#endif

/*  Windows t@CAEH[ */
#define FW_PROTOCOL_TCP		0	// TCP |[gԍ
#define FW_PROTOCOL_UDP		1	// UDP |[gԍ

/* GNX|[g֐ */
typedef VOID (APIENTRY *LPGETNATIVESYSTEMINFO)(LPSYSTEM_INFO);
typedef BOOL (APIENTRY *LPWFADDAPP)(LPCSTR, LPCSTR);
typedef BOOL (APIENTRY *LPFWREMOVEAPP)(LPCSTR);
typedef BOOL (APIENTRY *LPFWADDPORT)(LPCSTR, DWORD, LONG);
typedef BOOL (APIENTRY *LPFWREMOVEPORT)(DWORD, LONG);
typedef BOOL (APIENTRY *LPWFADDAPP2)(LPCSTR, LPCSTR, LPCSTR);
typedef BOOL (APIENTRY *LPFWADDPORT2)(LPCSTR, DWORD, LONG);
typedef BOOL (APIENTRY *LPFWREMOVEPOLICY)(LPCSTR);


/*----------------------------------------------------------------------------*/
/*		ϐ`                                                              */
/*----------------------------------------------------------------------------*/
HINSTANCE			hInst = NULL;

LPWFADDAPP			lpfnWindowsFirewallAddApp = NULL;
LPFWREMOVEAPP		lpfnWindowsFirewallRemoveApp = NULL;
LPFWADDPORT			lpfnWindowsFirewallAddPort = NULL;
LPFWREMOVEPORT		lpfnWindowsFirewallRemovePort = NULL;
LPWFADDAPP2			lpfnWindowsFirewallAddApp2 = NULL;
LPFWADDPORT2		lpfnWindowsFirewallAddPort2 = NULL;
LPFWREMOVEPOLICY	lpfnWindowsFirewallRemovePolicy = NULL;


/*----------------------------------------------------------------------------*/
/*		֐`                                                              */
/*----------------------------------------------------------------------------*/
BOOL APIENTRY DlgProc(HWND, WORD, WPARAM, LPARAM);


/*----------------------------------------------------------------------------*/
/*		݂̃JgpX擾鏈                                      */
/*----------------------------------------------------------------------------*/
void GetCurPath(
	LPTSTR	pBuffer,
	DWORD	cbBuf
)
{
	int	i;

	GetModuleFileName(hInst, pBuffer, cbBuf);

	i = lstrlen(pBuffer);
	while (i)
	{
		if (*(pBuffer + i) == 0x5C)
		{
			*(pBuffer + i + 1) = '\0';
			break;
		}
		i--;
	}

}


/*---------------------------------------------------------------------------*/
/*		64 rbgœ삵Ă邩`FbN鏈                        */
/*---------------------------------------------------------------------------*/
BOOL IsW64Process()
{
	SYSTEM_INFO				sysif;
	HINSTANCE				hDll;
	LPGETNATIVESYSTEMINFO	lpfnGetNativeSystemInfo = NULL;
	BOOL					bRet = FALSE;

	// Kernel32.dll [h
	if ((hDll = LoadLibrary("Kernel32.dll")) == NULL)	return (FALSE);

	// GNX|[gꂽ֐̃AhX擾
	if (!(lpfnGetNativeSystemInfo =
		(LPGETNATIVESYSTEMINFO)GetProcAddress(hDll, "GetNativeSystemInfo")))
	{
		FreeLibrary(hDll);
		return (FALSE);
	}

	// VXe擾
	ZeroMemory(&sysif, sizeof(SYSTEM_INFO));
	(lpfnGetNativeSystemInfo)(&sysif);

	// 64-bit Windows ł邩`FbN
	switch (sysif.wProcessorArchitecture)
	{
	case PROCESSOR_ARCHITECTURE_IA64:
	case PROCESSOR_ARCHITECTURE_IA32_ON_WIN64:
	case PROCESSOR_ARCHITECTURE_AMD64:
		bRet = TRUE;
		break;

	default:
		bRet = FALSE;
		break;
	}

	FreeLibrary(hDll);

	return (bRet);

}


/*----------------------------------------------------------------------------*/
/*		EBhEC                                                  */
/*----------------------------------------------------------------------------*/
int APIENTRY WinMain(
	HINSTANCE	hInstance,
	HINSTANCE	hPrevInstance,
	LPSTR		lpCmdLine,
	int			nCmdShow
)
{
	INITCOMMONCONTROLSEX	icc;
	HINSTANCE				hDll;
	TCHAR					szDllName[MAX_PATH + 1];

	// CX^Xۑ
	hInst = hInstance;

	// RRg[
	InitCommonControls();
	icc.dwSize = sizeof(INITCOMMONCONTROLSEX);
	icc.dwICC  = ICC_WIN95_CLASSES | ICC_INTERNET_CLASSES;
	InitCommonControlsEx(&icc);

	// _Setup.dll [h
	GetCurPath(szDllName, sizeof(szDllName));
	lstrcat(szDllName, "_Setup.dll");
	if ((hDll = LoadLibrary(szDllName)) == NULL)	return (FALSE);

	// GNX|[gꂽ֐̃AhX擾
	if (!(lpfnWindowsFirewallAddApp =
		(LPWFADDAPP)GetProcAddress(hDll, "WindowsFirewallAddApp")))			goto FAILED;
	if (!(lpfnWindowsFirewallRemoveApp =
		(LPFWREMOVEAPP)GetProcAddress(hDll, "WindowsFirewallRemoveApp")))	goto FAILED;
	if (!(lpfnWindowsFirewallAddPort =
		(LPFWADDPORT)GetProcAddress(hDll, "WindowsFirewallAddPort")))		goto FAILED;
	if (!(lpfnWindowsFirewallRemovePort =
		(LPFWREMOVEPORT)GetProcAddress(hDll, "WindowsFirewallRemovePort")))	goto FAILED;

	if (!(lpfnWindowsFirewallAddApp2 =
		(LPWFADDAPP2)GetProcAddress(hDll, "WindowsFirewallAddApp2")))		goto FAILED;
	if (!(lpfnWindowsFirewallAddPort2 =
		(LPFWADDPORT2)GetProcAddress(hDll, "WindowsFirewallAddPort2")))		goto FAILED;
	if (!(lpfnWindowsFirewallRemovePolicy =
		(LPFWREMOVEPOLICY)GetProcAddress(hDll, "WindowsFirewallRemovePolicy")))	goto FAILED;

	// _CAO{bNX\
	DialogBox(hInst, MAKEINTRESOURCE(DLG_MAIN), NULL, (DLGPROC)DlgProc);

FAILED:
	FreeLibrary(hDll);

	return (TRUE);

}


/*----------------------------------------------------------------------------*/
/*		SXUPTP Driver CXg[鏈                                  */
/*----------------------------------------------------------------------------*/
static BOOL OnClickInstall(
	HWND	hDlg,
	LPTSTR	lpszParam
)
{
	STARTUPINFO				si;
	PROCESS_INFORMATION		pi;
	TCHAR					szPath[MAX_PATH + 1], szName[MAX_PATH + 1];
	TCHAR					szAppName[MAX_PATH + 1];

	// SXUPTP Driver ZbgAbvN
	GetCurPath(szPath, sizeof(szPath));
	lstrcpy(szAppName, szPath);
	if (IsW64Process())
	{
		lstrcat(szAppName, "Driver\\Sxcsapi64.exe");
		wsprintf(szName, "Sxcsapi64.exe %s", lpszParam);
	}
	else
	{
		lstrcat(szAppName, "Driver\\Sxcsapi32.exe");
		wsprintf(szName, "Sxcsapi32.exe %s", lpszParam);
	}

	ZeroMemory(&si, sizeof(si));
	ZeroMemory(&pi, sizeof(pi));
	si.cb          = sizeof(STARTUPINFO);
	si.dwFlags     = STARTF_USESHOWWINDOW;
	si.wShowWindow = SW_SHOWNORMAL;

	if (!CreateProcess(szAppName, szName, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi))
		return (FALSE);

	CloseHandle(pi.hThread);
	CloseHandle(pi.hProcess);

	return (TRUE);

}


/*----------------------------------------------------------------------------*/
/*		OXgɃAvP[Vo^鏈                            */
/*----------------------------------------------------------------------------*/
static BOOL OnClickAddApp(HWND hDlg)
{
	TCHAR	szAppPath[MAX_PATH + 1];

	GetModuleFileName(hInst, szAppPath, sizeof(szAppPath));

	return ((lpfnWindowsFirewallAddApp)("Sample Program", szAppPath));

}


/*----------------------------------------------------------------------------*/
/*		OXgAvP[V폜鏈                          */
/*----------------------------------------------------------------------------*/
static BOOL OnClickDelApp(HWND hDlg)
{
	TCHAR	szAppPath[MAX_PATH + 1];

	GetModuleFileName(hInst, szAppPath, sizeof(szAppPath));

	return ((lpfnWindowsFirewallRemoveApp)(szAppPath));

}


/*----------------------------------------------------------------------------*/
/*		|[gԍOXgɓo^鏈                                  */
/*----------------------------------------------------------------------------*/
static BOOL OnClickAddPort(HWND hDlg)
{
	return ((lpfnWindowsFirewallAddPort)("SXUPTP", 1, 19540));
}


/*----------------------------------------------------------------------------*/
/*		|[gԍO폜鏈                                      */
/*----------------------------------------------------------------------------*/
static BOOL OnClickDelPort(HWND hDlg)
{
	return ((lpfnWindowsFirewallRemovePort)(1, 19540));
}


/*----------------------------------------------------------------------------*/
/*		OXgɃAvP[Vo^鏈                            */
/*----------------------------------------------------------------------------*/
static BOOL OnClickAddApp2(HWND hDlg)
{
	TCHAR	szAppPath[MAX_PATH + 1];

	GetModuleFileName(hInst, szAppPath, sizeof(szAppPath));

	return ((lpfnWindowsFirewallAddApp2)("Sample Program", szAppPath, "This is sample program."));

}


/*----------------------------------------------------------------------------*/
/*		|[gԍOXgɓo^鏈                                  */
/*----------------------------------------------------------------------------*/
static BOOL OnClickAddPort2(HWND hDlg)
{
	return ((lpfnWindowsFirewallAddPort2)("SXUPTP", 1, 19540));
}


/*----------------------------------------------------------------------------*/
/*		|V[O폜鏈                                        */
/*----------------------------------------------------------------------------*/
static BOOL OnClickDelPolicy(HWND hDlg)
{
	return ((lpfnWindowsFirewallRemovePolicy)("SXUPTP"));
}


/*----------------------------------------------------------------------------*/
/*		CʃR[obN֐                                            */
/*----------------------------------------------------------------------------*/
BOOL APIENTRY
DlgProc(
	HWND	hDlg,
	WORD	Msg,
	WPARAM	wParam,
	LPARAM	lParam
)
{

	switch (Msg)
	{
	case WM_INITDIALOG:
		return (TRUE);

	case WM_ENDSESSION:
	case WM_DESTROY:
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDOK:
		case IDCANCEL:
			EndDialog(hDlg, LOWORD(wParam));
			return (TRUE);

		case IDC_BTN_INSTALL:
			OnClickInstall(hDlg, "-install");
			return (TRUE);

		case IDC_BTN_UNINSTALL:
			OnClickInstall(hDlg, "-uninstall");
			return (TRUE);

		case IDC_BTN_AADD:
			OnClickAddApp(hDlg);
			return (TRUE);

		case IDC_BTN_ADEL:
			OnClickDelApp(hDlg);
			return (TRUE);

		case IDC_BTN_PADD:
			OnClickAddPort(hDlg);
			return (TRUE);

		case IDC_BTN_PDEL:
			OnClickDelPort(hDlg);
			return (TRUE);

		case IDC_BTN_AADD2:
			OnClickAddApp2(hDlg);
			return (TRUE);

		case IDC_BTN_PADD2:
			OnClickAddPort2(hDlg);
			return (TRUE);

		case IDC_BTN_ODEL:
			OnClickDelPolicy(hDlg);
			return (TRUE);
		}
		break;
	}

	return (FALSE);

}
