/*******************************************************************************
*                                                                              *
*	Win32 SXUPTP Library                                                       *
*                                                                              *
*   silex technology, Inc. CONFIDENTIAL                                        *
*                                                                              *
*----------+---------+---------------------------------------------------------*
*   t   | Version |                           e                          *
*----------+---------+---------------------------------------------------------*
* 04-07-27 |  1.0.0  |                                                         *
*----------+---------+---------------------------------------------------------*
* 06-12-20 |  1.2.0  | ^\PbgŊ֐ǉ                              *
*----------+---------+---------------------------------------------------------*
* 07-01-15 |  1.3.0  | JCP [ԍݒ֐ǉ                        *
*          |         | PnP mFtڑ^ؒf֐ǉ                    *
*----------+---------+---------------------------------------------------------*
* 08-12-14 |  1.4.0  | SX Keep Alive @\̒ǉ                                *
*----------+---------+---------------------------------------------------------*
* 09-04-27 |  1.5.0  | JCP  CPU gp}悤ɑΉ               *
*----------+---------+---------------------------------------------------------*
* 09-09-02 |  1.6.0  | foCXT[oċN API ǉ                         *
*----------+---------+---------------------------------------------------------*
* 13-06-13 |  1.8.0  | SXPSERVER \̂ɃzXg(szHostName)ǉ            *
*          |         | VXeXe[^X擾֐ǉ                        *
*----------+---------+---------------------------------------------------------*
* 13-12-06 |  2.0.0  | ؒfv API ǉ                                       *
*----------+---------+---------------------------------------------------------*
* 14-03-03 |  2.1.0  | CX^X ID 擾 API ǉ                           *
*----------+---------+---------------------------------------------------------*
* 16-07-22 |  2.9.0  | USB f[^ÍAڑpX[h@\ǉ                *
*----------+---------+---------------------------------------------------------*
* 20-04-16 |  3.0.0  | IPv6 Ή                                               *
*----------+---------+---------------------------------------------------------*
*******************************************************************************/
#ifndef _INC_SXUPTP_H
#define _INC_SXUPTP_H


/*----------------------------------------------------------------------------*/
/*		萔`                                                              */
/*----------------------------------------------------------------------------*/
#define SXUPTP_MACHINE		16				// @햼ől
#define SXUPTP_PORT			32				// USB _|[gől
#define SXUPTP_DEVICE		64				// foCXől
#define SXUPTP_LOCATION		16				// ڑʒu
#define SXUPTP_HOSTNAME		16				// zXgől
#define SXUPTP_PASSWORD		16				// ڑpX[hől

#define SRU_NOTIFY			(WM_APP + 800)	// Request Use Cxg
#define SRU_REQUEST			0x0001			// USB foCXgpvM
#define SRU_CANCEL			0x0002			// gpvLZ
#define SRU_ACCEPT			0x0003			// gpvt
#define SRU_REFUSE			0x0004			// gpv
#define SRU_DISCONNECT		0x0005			// ؒf
#define SRU_BUSY			0x0006			// ҂Ɖb
#define SRU_REPLY			0x0007			// gpv̎M
#define SRU_NOTFOUND		0x0008			// USB foCXȂ
#define SRU_REPLYEX			0x0009			// M(ؒfL)
#define SRU_DISCONTIME		0x000B			// ؒf܂ł̎cԉ
#define SRU_CONFIRM			0xFFFE			// USB foCXڑԊmF
#define SRU_TIMEOUT			0xFFFF			// ʐM^CAEg


/*----------------------------------------------------------------------------*/
/*		\̒`                                                            */
/*----------------------------------------------------------------------------*/
#pragma pack(1)
typedef struct _SXPSERVER {
	BYTE	bNodeaddr[6];					// Ethernet AhX
	DWORD	dwIp;							// IPv4 AhX
	BYTE	bIpAddress[16];					// IPv6 AhX
	char	szMachineType[SXUPTP_MACHINE];	// foCXT[o@햼
	char	szHostName[SXUPTP_HOSTNAME];	// zXg
} SXPSERVER, *LPSXPSERVER;

typedef struct _SXUSBDEVICE {
	char	szPortName[SXUPTP_PORT];		// USB _|[g
	char	szDeviceName[SXUPTP_DEVICE];	// foCX
	DWORD	dwIpPc;							// ڑ PC  IPv4 AhX
	BYTE	bIpAddrPc[16];					// ڑ PC  IPv6 AhX
	WORD	wStatus;						// Xe[^X
	WORD	wVid;							// foCX VID
	WORD	wPid;							// foCX PID
	char	szLocation[SXUPTP_LOCATION];	// foCXڑʒu
	WORD	wClass;							// USB Interface Class
} SXUSBDEVICE, *LPSXUSBDEVICE;

typedef struct _SRUINFO {
	DWORD	dwSize;							// SRUINFO \̃TCY
	WORD	wMessage;						// SVL Request Use Message
	BYTE	bIpAddr[16];					// M PC  IP AhX
	int		iIpAddrlen;						// MAhXTCY
	char	szMyName[64];					// M([U[Rs[^)
	char	szDestName[64];					// M於([U[Rs[^)
	BYTE	bSrvIpAddr[16];					// foCXT[o IP AhX
	int		iSrvIpAddlen;					// foCXT[oAhXTCY
	BYTE	bNodeaddr[6];					// foCXT[o Ethernet AhX
	WORD	wVid;							// VID ( ID)
	WORD	wPid;							// PID (i ID)
	char	szDeviceName[SXUPTP_DEVICE];	// USB foCX
	char	szLocation[16];					// USB foCXʒu
	DWORD	dwRemainingTime;				// ؒfs܂ł̎c (b)
} SRUINFO, *LPSRUINFO;

typedef struct _SXDEVINST {
	LPSTR	lpszInstanceId;					// CX^X ID
} SXDEVINST, *LPSXDEVINST;
#pragma pack()


/*----------------------------------------------------------------------------*/
/*		֐`                                                              */
/*----------------------------------------------------------------------------*/
BOOL APIENTRY SxuptpEnumDeviceServers(LPDWORD, DWORD, LPVOID, DWORD, LPDWORD, LPDWORD);
BOOL APIENTRY SxuptpEnumDevices(DWORD, LPVOID, DWORD, LPDWORD, LPDWORD);
BOOL APIENTRY SxuptpEnumDevicesV6(LPBYTE, int, LPVOID, DWORD, LPDWORD, LPDWORD);
BOOL APIENTRY SxuptpDeviceConnect(DWORD, LPBYTE, LPSTR, BOOL);
BOOL APIENTRY SxuptpDeviceConnectEx(DWORD, LPBYTE, LPSXUSBDEVICE, BOOL);
DWORD APIENTRY SxuptpDeviceConnectEx2(DWORD, LPBYTE, LPSXUSBDEVICE, DWORD, LPVOID);
DWORD APIENTRY SxuptpDeviceConnectV6(LPBYTE, int, LPBYTE, LPSXUSBDEVICE, DWORD, LPVOID);
BOOL APIENTRY SxuptpDeviceDisconnect(DWORD, LPBYTE, LPSTR);
BOOL APIENTRY SxuptpDeviceDisconnectEx(DWORD, LPBYTE, LPSXUSBDEVICE);
BOOL APIENTRY SxuptpDeviceDisconnectV6(LPBYTE, int, LPBYTE, LPSXUSBDEVICE);
BOOL APIENTRY SxuptpGetDeviceServerInfo(DWORD, LPVOID, DWORD);
BOOL APIENTRY SxuptpGetDeviceServerInfoV6(LPBYTE, int, LPVOID, DWORD);
DWORD APIENTRY SxuptpGetDeviceStatus(DWORD, LPSTR);
DWORD APIENTRY SxuptpGetDeviceStatusV6(LPBYTE, int, LPSTR);
BOOL APIENTRY SxuptpGetSystemStatus(DWORD, LPSTR, DWORD);
BOOL APIENTRY SxuptpSetSrchRuleCookie(WORD);
BOOL APIENTRY SxuptpRebootDeviceServer(DWORD, LPBYTE);
BOOL APIENTRY SxuptpRebootDeviceServerV6(LPBYTE, int, LPBYTE);

BOOL APIENTRY SruInitialize(HINSTANCE, HWND, LPCSTR);
BOOL APIENTRY SruUninitialize(HINSTANCE);
HANDLE APIENTRY SruSendRequest(HWND, DWORD, LPBYTE, LPSXUSBDEVICE, DWORD);
HANDLE APIENTRY SruSendRequestV6(HWND, LPBYTE, int, LPBYTE, LPSXUSBDEVICE, DWORD);
BOOL APIENTRY SruCancelRequest(HANDLE);
BOOL APIENTRY SruCloseHandle(HANDLE);
BOOL APIENTRY SruSendReply(WORD, DWORD);
BOOL APIENTRY SruAcceptRequest(VOID);
BOOL APIENTRY SruRefuseRequest(VOID);
BOOL APIENTRY SruDisconnectedDevice(VOID);
BOOL APIENTRY SruDeviceNotFound(VOID);

DWORD APIENTRY SxuptpGetInstanceId(DWORD, LPCSTR, LPSXDEVINST *);
DWORD APIENTRY SxuptpGetInstanceIdV6(LPBYTE, int, LPCSTR, LPSXDEVINST *);
BOOL APIENTRY SxuptpFreeInstanceId(LPSXDEVINST);

#endif /* _INC_SXUPTP_H */
